<template>
	
	<div>
		<div class="card shadow-sm">
			<div class="card-header d-flex align-items-center">
				<p class="lead m-0">Crear nueva cita</p>
			</div>
			<div class="card-body">
				
				<div class="row">
					<div class="col-sm-6 offset-3">
						<p>Campos requeridos marcados con (<span class="text-danger">*</span>)</p>
					</div>
				</div>

				<div class="form-group row" v-if="errors.length">
					<div class="col-sm-6 offset-3">
						<div class="alert alert-danger">
						    
						    <p class="m-0" v-for="(error, index) in errors" v-text="error"></p>

						</div>
					</div>
				</div>
	
				<div class="row">
					<div class="col-sm-6 offset-3">
						<p class="lead">Compañía que nos visita</p>
					</div>
				</div>
				
				<div class="form-group row" v-if="!independent">
					<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Compañía:</label>
					<div class="col-sm-6 d-flex align-items-center">
							
						<select name="company_id" 
							class="custom-select mr-2" 
							v-model="company_id" 
							@change="get_company_visitors"
							:disabled="independent ? true : false">
							
							<option disabled selected value="">Elige una opción</option>

							<option v-for="company in companies" :value="company.id" v-text="company.name"></option>

						</select>

						<div class="ml-auto pl-2 border-left">
							<a href="#" 
								class="btn btn-primary nowrap"
								data-toggle="modal"
								data-target="#newCompanyModal">
								<i class="fa fa-plus fa-sm mr-2"></i>
								Nueva
							</a>
						</div>

					</div>
				</div>

				<div class="form-group row">
					<div class="col-sm-6 offset-3">
						<div class="custom-control custom-switch">
							<input type="checkbox" 
								class="custom-control-input" 
								id="independentVisitorSwitch" 
								v-model="independent" 
								@change="set_independent_visitor">
							<label class="custom-control-label" for="independentVisitorSwitch">Visita independiente</label>
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-sm-6 offset-3">
						<p class="lead">Elige los visitantes</p>
					</div>
				</div>

				<div class="form-group row">
					<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Agregar visitantes:</label>
					
					<div class="col-sm-6 d-flex align-items-center">
						<div class="d-flex align-items-center w-100" 
							:class="company_id ? 'mr-2' : ''"
							v-if="!independent">

							<select name="visitors" 
								v-model="visitor_id" 
								class="custom-select" 
								:disabled="visitors.length ? false : true"
								@change="add_visitor_to_list">
								
								<option disabled selected value="">Elige una opción</option>

								<option v-for="visitor in visitors" :value="visitor.id" v-text="visitor.full_name +' | '+ visitor.type"></option>

							</select>

						</div>

						<div :class="!independent ? 'pl-2 border-left' : ''" 
							v-if="company_id">
							<a href="#" class="btn btn-primary nowrap"
								data-toggle="modal"
								data-target="#newVisitorModal">
								<i class="fa fa-plus fa-sm mr-2"></i>
								Nuevo
							</a>
						</div>
					</div>

				</div>

				
				<div class="form-group row" v-if="visitors_list.length">
					<label class="col-sm-3 col-form-label text-right">Visitantes agregados:</label>
					<div class="col-sm-6">
						<ul class="list-group">
							<li v-for="(visitor, index) in visitors_list" class="list-group-item">
								
								<span v-text="visitor.full_name +' | '+ visitor.type"></span>

								<button type="button" 
									class="close text-danger" 
									aria-label="Close" 
									@click.prevent="remove_visitor(index)">

								  	<span aria-hidden="true">&times;</span>

								</button>

							</li>
						</ul>
					</div>
				</div>

				<div class="form-group row">
					<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Asunto:</label>
					<div class="col-sm-6">
						<input type="text" name="subject" v-model="subject" class="form-control">
					</div>
				</div>

				<div class="form-group row">
					<label class="col-sm-3 col-form-label text-right">Descripción:</label>
					<div class="col-sm-6">
						<textarea name="description" v-model="description" rows="4" class="form-control"></textarea>
					</div>
				</div>

				<div class="form-group row">
					<label class="col-sm-3 col-form-label text-right">Fecha y hora:</label>
					<div class="col-sm-4">
						
						<date-picker v-model="start_at" 
							type="datetime" 
							input-class="form-control w-100"
							placeholder="Fecha y hora"
							format="DD-MM-YYYY hh:mm a"
							:minute-step="5"
							lang="es" />

					</div>
				</div>

				<div class="form-group row">
					<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Vigencia:</label>
					<div class="col-sm-4">
						<select name="vigency" v-model="vigency" id="" class="custom-select">
							<option disabled selected value="">Elige una opción</option>
							<option value="1">1 Hora</option>
							<option value="2">2 Horas</option>
							<option value="5">5 Horas</option>
							<option value="8">8 Horas</option>
							<option value="0">Todo el día</option>
						</select>
					</div>
				</div>

				<div v-if="role != 'host'">

					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Departamento:</label>
						<div class="col-sm-4">
							<select name="department_id" 
								v-model="department_id" 
								id="" 
								class="custom-select"
								@change="get_department_hosts">
								<option disabled selected value="">Elige una opción</option>
								<option v-for="department in departments" :value="department.id" v-text="department.name"></option>
							</select>
						</div>
					</div>


					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Visitado:</label>
						<div class="col-sm-4">
							<select name="host" v-model="host_id" id="" class="custom-select" :disabled="hosts.length   ? false : true">
								<option disabled selected value="">Elige una opción</option>
								<option v-for="host in hosts" :value="host.id" v-text="host.full_name"></option>
							</select>
						</div>
					</div>

				</div>

			</div>
			<div class="card-footer">
				
				<div class="form-group row mb-0">
					<div class="col-sm-6 offset-3">
						<button class="btn btn-primary" 
							@click.prevent="submit_date_form"
							ref="new_date_btn">
							<i class="fa fa-check mr-2"></i> 
							Agendar cita
						</button>
					</div>
				</div>

			</div>
		</div>
	
		<!-- MODAL PARA CREAR NUEVA COMPAÑIA -->

		<modal id="newCompanyModal" title="Agregar nueva compañía" size="modal-lg">
			<template #default>
	
				<form action="" 
					id="newCompanyForm" 
					@submit.prevent="submit_new_company_form">
		
					<div class="form-group row mb-0">
						<div class="col-sm-6 offset-3">
							<p>Campos requeridos marcados con (<span class="text-danger">*</span>)</p>
						</div>
					</div>
					
					<div class="form-group row" v-if="new_company.errors.length">
						<div class="col-sm-6 offset-3">
							<div class="alert alert-danger alert-dismissible fade show" role="alert">
							    
							    <p class="m-0" v-for="error in new_company.errors" v-text="error"></p>

							    <button type="button" class="close" @click.prevent="new_company.errors = []">
							    	
							    	<span aria-hidden="true">&times;</span>

							    </button>

							</div>
						</div>
					</div>

					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right"><span class="text-danger">*</span>Nombre:</label>
						<div class="col-sm-6">
							<input type="text" v-model="new_company.name" class="form-control" required>
						</div>
					</div>

				</form>
			</template>

			<template #footer>
				<div class="w-100">
					<div class="col-sm-6 offset-3 px-2">
						<button type="submit" class="btn btn-primary" form="newCompanyForm">
							<i class="fa fa-check mr-2"></i>
							Guardar
						</button>
					</div>
				</div>
			</template>
		</modal>
	
		<!-- MODAL PARA CREAR NUEVO VISITANTE -->

		<modal id="newVisitorModal" title="Agregar nuevo visitante" size="modal-lg">
			<template #default>
	
				<form action="" 
					method="post"  
					id="newVisitorForm"
					@submit.prevent="submit_new_visitor_form">

					<div class="form-group row">
						<div class="col-sm-7 offset-3">
							
							Campos requeridos marcardos con (<span class="text-danger">*</span>)

						</div>
					</div>
					
					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right">
							<span class="text-danger">*</span>
							Nombre(s):
						</label>
						<div class="col-sm-7">
							<input name="first_name" 
								type="text"
								v-model="new_visitor.first_name"
								class="form-control" 
								required>
						</div>
					</div>


					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right">
							<span class="text-danger">*</span>
							Apellido(s):
						</label>
						<div class="col-sm-7">
							<input name="last_name" 
								type="text"
								v-model="new_visitor.last_name"
								class="form-control"
								required>
						</div>
					</div>

					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right">E-mail:</label>
						<div class="col-sm-7">
							<input name="email" 
								type="email" 
								v-model="new_visitor.email"
								class="form-control">
						</div>
					</div>

					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right">Puesto:</label>
						<div class="col-sm-7">
							<input name="jobtitle" 
								type="text"
								v-model="new_visitor.jobtitle"
								class="form-control">
						</div>
					</div>

					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right">
							<span class="text-danger">*</span>
							Género:
						</label>
						<div class="col-sm-7">
							<select name="gender_id" 
								class="custom-select"
								v-model="new_visitor.gender_id">
								<option disabled selected value="">Elige una opción</option>
								<option value="0">Masculino</option>
								<option value="1">Femenino</option>
							</select>
						</div>
					</div>

					<div class="form-group row">
						<label class="col-sm-3 col-form-label text-right">
							<span class="text-danger">*</span>
							Tipo:
						</label>
						<div class="col-sm-7">
							<select name="type_id"
								class="custom-select"
								v-model="new_visitor.type_id">
								<option disabled selected value="">Elige una opción</option>
								<option value="0">Visita general</option>
								<option value="1">Vendedor</option>
								<option value="2">Proveedor</option>
								<option value="3">Otro</option>
							</select>
						</div>
					</div>

				</form>
				
			</template>

			<template #footer>
				<div class="w-100">
					<div class="col-sm-6 offset-3 px-2">
						<button type="submit" 
							class="btn btn-primary" 
							form="newVisitorForm">
						
							<i class="fa fa-check mr-2"></i>

							Guardar

						</button>
					</div>
				</div>
			</template>

		</modal>
	</div>

</template>

<script>
	
	import DateStart from './DateStart';
	import Modal from './Modal';
	import DatePicker from 'vue2-datepicker';
	import 'vue2-datepicker/index.css';
	import 'vue2-datepicker/locale/es';

	export default {

		components: {DateStart, Modal, DatePicker},

		props: ['company', 'department', 'host', 'role', 'user_id', 'date_start_at'],

		data(){

			return {

				errors: [],
				company_id: this.company ? this.company : '',
				companies: [],
				independent: false,
				visitors: [],
				visitor_id: '',
				visitors_list: [],
				start_at: this.date_start_at ? new Date(this.date_start_at) : new Date(),
				new_visitor: {
					first_name: '',
					last_name: '',
					email: '',
					jobtitle: '',
					gender_id: '',
					type_id: '',
					errors: []
				},
				new_company: {
					name: '',
					errors: []
				},
				subject: '',
				description: '',
				vigency: '',
				departments: [],
				department_id: this.department ? this.department : '',
				hosts: [],
				host_id: ''

			}

		},

		mounted(){

			this.get_companies();

			this.get_company_visitors();

			this.get_departments();

			this.validate_if_user_is_host();

			if(this.department_id){

				this.get_department_hosts();

			}

		},

		methods: {

			validate_if_user_is_host(){

				let t = this;

				if(t.role == 'host'){

					let route = t.$root.$data.root + '/user/'+ t.user_id +'/host';

					axios.get(route).then(({ data }) => { 
						t.department_id = data.department_id;
						t.host_id = data.id;
					});

				}

			},

			get_companies(){

				let t = this;

				let route = t.$root.$data.root + '/companies';

				axios.get(route).then(({ data }) => {
				
					t.companies = data;
				
				});

			},

			get_company_visitors(){

				let t = this;

				if(t.company_id){

					let route = t.$root.$data.root + '/companies/' + t.company_id + '/visitors';

					axios.get(route).then(({ data }) => {
						
						t.visitor_id = '';

						t.visitors = data;

						t.visitors_list = [];
					
					});

				}

			},

			submit_new_visitor_form(){

				let t = this;

				let route = t.$root.$data.root + '/companies/' + t.company_id + '/visitors';

				let data = new FormData();

				data.append('first_name', t.new_visitor.first_name);
				data.append('last_name', t.new_visitor.last_name);
				data.append('email', t.new_visitor.email);
				data.append('jobtitle', t.new_visitor.jobtitle);
				data.append('type_id', t.new_visitor.type_id);
				data.append('gender_id', t.new_visitor.gender_id);


				axios.post(route, data).then(({ data }) => {
				
				
					t.visitors.push(data);

					$('.modal').modal('hide');

					t.visitor_id = '';

					t.visitors_list.push(data);

					t.new_visitor = {

						first_name: '',
						last_name: '',
						email: '',
						jobtitle: '',
						gender_id: '',
						errors: []

					}
				
				
				});
				

 
			},

			set_independent_visitor(){

				let t = this;

				if(t.independent){

					t.company_id = 1;

					t.get_company_visitors();

					t.visitors_list = [];

				}else{

					t.company_id = '';
					t.visitors = [];
					t.visitor_id = '';

					t.visitors_list = [];

				}

			},

			submit_new_company_form(){

				let t = this;

				let route = t.$root.$data.root + '/companies';

				let data = new FormData();

				data.append('name', t.new_company.name);


				axios.post(route, data).then(({ data }) => {
				
					t.companies.push(data);

					t.company_id = data.id;

					t.visitors = [];

					t.visitor_id = '';

					t.new_company.errors = [];

					t.new_company.name = '';

					$('.modal').modal('hide');
				
				}).catch((error) => {

					console.log(error.response);
					
					for(let msg in error.response.data.errors){
					
						let error_msg = error.response.data.errors[msg][0];
					
						t.new_company.errors.push(error_msg);
					
					}

				});
				

			},

			add_visitor_to_list(){

				let t = this;

				let is_already_added = false;

				t.visitors_list.forEach((visitor, index) => {

					if(visitor.id == t.visitor_id){

						is_already_added = true;

					}

				});

				if(is_already_added){

					alert('El visitante ya ha sido agregado.');

					t.visitor_id = '';

				}else{

					let route = t.$root.$data.root + '/companies/' + t.company_id + '/visitors/' + t.visitor_id;

					axios.get(route).then(({ data }) => {
					
						t.visitors_list.push(data);
					
					});

				}
				
			},

			remove_visitor(index){

				let t = this;

				let confirm = window.confirm('¿Estas seguro que deseas remover a este visitante?');

				if(confirm){

					t.visitors_list.splice(index, 1);

				}

			},

			get_departments(){

				let t = this;

				let route = t.$root.$data.root + '/departments';

				axios.get(route).then(({ data }) => {
				
					t.departments = data;
				
				});

			},

			get_department_hosts(){

				let t = this;

				let route = t.$root.$data.root + '/departments/' + t.department_id + '/hosts';

				axios.get(route).then(({ data }) => {
				
					t.hosts = data;

					t.host_id = t.host ? t.host : '';
				
				});

			},

			submit_date_form(){

				let t = this;

				let btn = t.$refs.new_date_btn;

				let route = t.$root.$data.root + '/dates';

				let data = new FormData();

				data.append('subject', t.subject);
				data.append('description', t.description);
				data.append('date', t.start_at.toLocaleString());
				data.append('vigency', t.vigency);
				data.append('company_id', t.company_id);
				data.append('visitors', JSON.stringify(t.visitors_list));
				data.append('department_id', t.department_id);
				data.append('host_id', t.host_id);

				btn.setAttribute('disabled', 'disabled');

				t.errors = [];

				axios.post(route, data).then(({ data }) => {
				
					let route = t.$root.$data.root + '/dates/' + data.id + '?new_date=true';

					window.location.href = route;
				
				}).catch((error) => {

					console.log(error.response);
					
					for(let msg in error.response.data.errors){
					
						let error_msg = error.response.data.errors[msg][0];
					
						t.errors.push(error_msg);
					
					}
					
					btn.removeAttribute('disabled');

				});
				
			}

		},
		
	}

</script>